﻿Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Excel = Microsoft.Office.Interop.Excel

'Add-in Express Add-in Module
<GuidAttribute("0C005B3A-22C1-47F2-9202-277323C90238"), ProgIdAttribute("WorkingWithWorkbooks.AddinModule")> _
Public Class AddinModule
    Inherits ADXAddinModule
    Friend WithEvents AdxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents AdxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents btnGetWorkbook As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnMakeFavorite As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnGetPath As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnGetFullPath As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnGetName As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnEditBuiltInProp As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnEditCustomProp As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnSaveWB As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents AdxRibbonGroup3 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents AdxRibbonButtonGroup6 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents AdxRibbonButtonGroup5 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents AdxRibbonButtonGroup4 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents AdxRibbonButtonGroup3 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents AdxRibbonButtonGroup2 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents AdxRibbonGroup2 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents btnActiveSheet As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnWorksheetName As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnGetSheetByIndex As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnCodeName As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnCopySheet As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnHide As AddinExpress.MSO.ADXRibbonButton

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.AdxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.AdxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.btnGetWorkbook = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnMakeFavorite = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnGetPath = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnGetFullPath = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnGetName = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnEditBuiltInProp = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnEditCustomProp = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnSaveWB = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.AdxRibbonGroup3 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.btnActiveSheet = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnWorksheetName = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnGetSheetByIndex = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnCodeName = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnCopySheet = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnHide = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.AdxRibbonButtonGroup6 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.AdxRibbonButtonGroup5 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.AdxRibbonButtonGroup4 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.AdxRibbonButtonGroup3 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.AdxRibbonButtonGroup2 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.AdxRibbonGroup2 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        '
        'AdxRibbonTab1
        '
        Me.AdxRibbonTab1.Caption = "WORKING WORKBOOKS"
        Me.AdxRibbonTab1.Controls.Add(Me.AdxRibbonGroup1)
        Me.AdxRibbonTab1.Controls.Add(Me.AdxRibbonGroup3)
        Me.AdxRibbonTab1.Id = "adxRibbonTab_a170e7f865284fb8af4ee33e0b9c275a"
        Me.AdxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonGroup1
        '
        Me.AdxRibbonGroup1.Caption = "Workbooks"
        Me.AdxRibbonGroup1.Controls.Add(Me.btnGetWorkbook)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnMakeFavorite)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnGetPath)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnGetFullPath)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnGetName)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnEditBuiltInProp)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnEditCustomProp)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnSaveWB)
        Me.AdxRibbonGroup1.Id = "adxRibbonGroup_0225f12ba4da4f9296d915ccfa2c2b95"
        Me.AdxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnGetWorkbook
        '
        Me.btnGetWorkbook.Caption = "GetWorkbook"
        Me.btnGetWorkbook.Id = "adxRibbonButton_c26fcd70608f4f6e913a8e923eca3adf"
        Me.btnGetWorkbook.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnGetWorkbook.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnMakeFavorite
        '
        Me.btnMakeFavorite.Caption = "Make Favorite"
        Me.btnMakeFavorite.Id = "adxRibbonButton_3918785f84c74919bb8a814791d2a6fc"
        Me.btnMakeFavorite.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnMakeFavorite.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnGetPath
        '
        Me.btnGetPath.Caption = "Get Path"
        Me.btnGetPath.Id = "adxRibbonButton_ad99c378c45647c4a3a5dbb1d326fa87"
        Me.btnGetPath.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnGetPath.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnGetFullPath
        '
        Me.btnGetFullPath.Caption = "Get Full Path"
        Me.btnGetFullPath.Id = "adxRibbonButton_0d0e078747754ee6b129def142c990c2"
        Me.btnGetFullPath.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnGetFullPath.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnGetName
        '
        Me.btnGetName.Caption = "Get Name"
        Me.btnGetName.Id = "adxRibbonButton_13b22f12a7bb4bb5bb29b5c9d151abd5"
        Me.btnGetName.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnGetName.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnEditBuiltInProp
        '
        Me.btnEditBuiltInProp.Caption = "Edit Built-in Property"
        Me.btnEditBuiltInProp.Id = "adxRibbonButton_104952a1ebe248988e02614793676c14"
        Me.btnEditBuiltInProp.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnEditBuiltInProp.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnEditCustomProp
        '
        Me.btnEditCustomProp.Caption = "Edit Custom Property"
        Me.btnEditCustomProp.Id = "adxRibbonButton_26cff23884c5426282ad3c7c3ce84272"
        Me.btnEditCustomProp.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnEditCustomProp.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnSaveWB
        '
        Me.btnSaveWB.Caption = "Save Workbook"
        Me.btnSaveWB.Id = "adxRibbonButton_9caa32e348c94a41a290e7d433eb0f05"
        Me.btnSaveWB.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnSaveWB.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonGroup3
        '
        Me.AdxRibbonGroup3.Caption = "Worksheets"
        Me.AdxRibbonGroup3.Controls.Add(Me.btnActiveSheet)
        Me.AdxRibbonGroup3.Controls.Add(Me.btnWorksheetName)
        Me.AdxRibbonGroup3.Controls.Add(Me.btnGetSheetByIndex)
        Me.AdxRibbonGroup3.Controls.Add(Me.btnCodeName)
        Me.AdxRibbonGroup3.Controls.Add(Me.btnCopySheet)
        Me.AdxRibbonGroup3.Controls.Add(Me.btnHide)
        Me.AdxRibbonGroup3.Id = "adxRibbonGroup_469db1161eb74664bf199aa787056c6e"
        Me.AdxRibbonGroup3.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnActiveSheet
        '
        Me.btnActiveSheet.Caption = "Get Active Sheet"
        Me.btnActiveSheet.Id = "adxRibbonButton_978e3c7cb4ed4596a6ed0cde629bc8aa"
        Me.btnActiveSheet.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnActiveSheet.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnWorksheetName
        '
        Me.btnWorksheetName.Caption = "GetWorksheetName"
        Me.btnWorksheetName.Id = "adxRibbonButton_81495f07853d419d9cc633f22c0ea1de"
        Me.btnWorksheetName.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnWorksheetName.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnGetSheetByIndex
        '
        Me.btnGetSheetByIndex.Caption = "Get Sheet by Index"
        Me.btnGetSheetByIndex.Id = "adxRibbonButton_ff616a775645463fb8959ad7a3965416"
        Me.btnGetSheetByIndex.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnGetSheetByIndex.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnCodeName
        '
        Me.btnCodeName.Caption = "Get By Code Name"
        Me.btnCodeName.Id = "adxRibbonButton_6190ee81c1f14f9f8343a05081be95e9"
        Me.btnCodeName.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnCodeName.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnCopySheet
        '
        Me.btnCopySheet.Caption = "Copy Sheet"
        Me.btnCopySheet.Id = "adxRibbonButton_513e058a2c004f0ab71640ee5766595c"
        Me.btnCopySheet.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnCopySheet.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'btnHide
        '
        Me.btnHide.Caption = "Hide Sheet"
        Me.btnHide.Id = "adxRibbonButton_62df8bb6a0c447ceab9c06748f734e1e"
        Me.btnHide.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnHide.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonButtonGroup6
        '
        Me.AdxRibbonButtonGroup6.Id = "adxRibbonButtonGroup_897e0cb1a8cd4342a5460ef7db1958ea"
        Me.AdxRibbonButtonGroup6.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonButtonGroup5
        '
        Me.AdxRibbonButtonGroup5.Id = "adxRibbonButtonGroup_aa4411e651774f52b1fa18ca826fb870"
        Me.AdxRibbonButtonGroup5.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonButtonGroup4
        '
        Me.AdxRibbonButtonGroup4.Id = "adxRibbonButtonGroup_a03f2afa232c4030829278456d3d5471"
        Me.AdxRibbonButtonGroup4.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonButtonGroup3
        '
        Me.AdxRibbonButtonGroup3.Id = "adxRibbonButtonGroup_8b89946defb84526865a81da79e967fa"
        Me.AdxRibbonButtonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonButtonGroup2
        '
        Me.AdxRibbonButtonGroup2.Id = "adxRibbonButtonGroup_40064e3499dd42a1baa1882e771a475b"
        Me.AdxRibbonButtonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AdxRibbonGroup2
        '
        Me.AdxRibbonGroup2.Caption = "Worksheets"
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonButtonGroup2)
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonButtonGroup3)
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonButtonGroup4)
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonButtonGroup5)
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonButtonGroup6)
        Me.AdxRibbonGroup2.Id = "adxRibbonGroup_121e06f923aa4a10b841bc7156e4e51a"
        Me.AdxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AddinModule
        '
        Me.AddinName = "WorkingWithWorkbooks"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property ExcelApp() As Excel._Application
        Get
            Return CType(HostApplication, Excel._Application)
        End Get
    End Property

#Region "Workbook Code"

    Private Function GetActiveWorkbook() As Excel.Workbook
        Return ExcelApp.ActiveWorkbook
    End Function

    Private Sub MakeFavorite(wb As Excel.Workbook)
        wb.AddToFavorites()
    End Sub

    Private Function GetPath(wb As Excel.Workbook) As String
        Return wb.Path
    End Function

    Private Function GetFullPath(wb As Excel.Workbook)
        Return wb.FullName
    End Function

    Private Function GetName(wb As Excel.Workbook)
        Return wb.Name
    End Function

    Private Sub ProtectWB(wb As Excel.Workbook, passWord As String, protect As Boolean)
        If protect Then
            wb.Protect(passWord, True, False)
        Else
            wb.Unprotect(passWord)
        End If
    End Sub

    Private Sub EditBuiltInProperty(wb As Excel.Workbook, _
        propName As String, propValue As String)

        Dim props As Microsoft.Office.Core.DocumentProperties = _
            wb.BuiltinDocumentProperties
        Dim prop As Microsoft.Office.Core.DocumentProperty = Nothing

        prop = props.Item(propName)
        If Not prop Is Nothing Then
            prop.Value = propValue
        End If

        'You can choose to save it.
        'I prefer to leave it to the user to do manually
        'wb.Save()

        Marshal.ReleaseComObject(prop)
        Marshal.ReleaseComObject(props)
    End Sub

    Private Sub EditCustomProperty(wb As Excel.Workbook, _
        propName As String, propValue As String)

        Dim props As Microsoft.Office.Core.DocumentProperties = _
            wb.CustomDocumentProperties
        Dim prop As Microsoft.Office.Core.DocumentProperty = Nothing

        For i = 1 To props.Count
            If props.Item(i).Name = propName Then
                prop = props.Item(i)
            End If
        Next

        If Not prop Is Nothing Then
            'If the property exists, edit it.
            prop.Value = propValue
        Else
            'It doesn't exist...so let's create it.
            props.Add(propName, False, _
                Microsoft.Office.Core.MsoDocProperties.msoPropertyTypeString, propValue)
        End If

        'You can choose to save it.
        'I prefer to leave it to the user to do manually
        'wb.Save()

        Marshal.ReleaseComObject(prop)
        Marshal.ReleaseComObject(props)
    End Sub

    Private Sub SaveWB(wb As Excel.Workbook)
        If wb.FileFormat = Excel.XlFileFormat.xlExcel9795 Then
            wb.SaveAs(wb.FullName, Excel.XlFileFormat.xlWorkbookNormal)
        Else
            wb.Save()
        End If
    End Sub

#End Region

#Region "Worksheet Code"

    Private Function GetActiveSheet() As Excel.Worksheet
        Return ExcelApp.ActiveSheet
    End Function

    Private Function GetWorksheetName(sheet As Excel.Worksheet)
        Return sheet.Name
    End Function

    Private Function GetSheetByIndex(wb As Excel.Workbook, index As Integer)
        Return wb.Worksheets(index)
    End Function

    Private Function GetSheetByName(wb As Excel.Workbook, sheetName As String)
        Return wb.Worksheets(sheetName)
    End Function

    Private Function GetWorksheetCodeName(sheet As Excel.Worksheet) As String
        Return sheet.CodeName
    End Function

    Private Sub CopyActiveSheet(newWorkbook As Boolean)
        Dim sheet As Excel.Worksheet = ExcelApp.ActiveSheet

        If newWorkbook Then
            sheet.Copy() 'Creates a new workbook and copies sheet into it
        Else
            sheet.Copy(, sheet)
        End If
    End Sub

    Private Sub HideSheet(ws As Excel.Worksheet, makeItHard As Boolean)
        If makeItHard Then
            ws.Visible = Excel.XlSheetVisibility.xlSheetVeryHidden
        Else
            ws.Visible = Excel.XlSheetVisibility.xlSheetHidden
        End If
    End Sub

#End Region

#Region " Workbook Button Code"
    Private Sub btnGetWorkbook_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnGetWorkbook.OnClick
        Dim wb As Excel.Workbook = GetActiveWorkbook()
        Marshal.ReleaseComObject(wb)
    End Sub

    Private Sub btnMakeFavorite_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnMakeFavorite.OnClick
        MakeFavorite(ExcelApp.ActiveWorkbook)
    End Sub

    Private Sub btnGetPath_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnGetPath.OnClick
        Dim text As String = GetPath(ExcelApp.ActiveWorkbook)
        MsgBox(text)
    End Sub

    Private Sub btnGetFullPath_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnGetFullPath.OnClick
        Dim text As String = GetFullPath(ExcelApp.ActiveWorkbook)
        MsgBox(text)
    End Sub

    Private Sub btnGetName_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnGetName.OnClick
        Dim text As String = GetName(ExcelApp.ActiveWorkbook)
        MsgBox(text)
    End Sub

    Private Sub btnEditBuiltInProp_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnEditBuiltInProp.OnClick
        EditBuiltInProperty(ExcelApp.ActiveWorkbook, "Title", "My Workbook")
    End Sub

    Private Sub btnEditCustomProp_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnEditCustomProp.OnClick
        EditCustomProperty(ExcelApp.ActiveWorkbook, "Ty's Property", "This is Ty's Custom Property")
    End Sub

    Private Sub btnSaveWB_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnSaveWB.OnClick
        SaveWB(ExcelApp.ActiveWorkbook)
    End Sub
#End Region

#Region "Worksheet Button Code"

    Private Sub btnActiveSheet_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnActiveSheet.OnClick
        Dim sheet As Excel.Worksheet = GetActiveSheet()
        Marshal.ReleaseComObject(sheet)
    End Sub

    Private Sub btnWorksheetName_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnWorksheetName.OnClick
        Dim text As String = GetWorksheetName(ExcelApp.ActiveSheet)
    End Sub

    Private Sub btnGetSheetByIndex_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnGetSheetByIndex.OnClick
        Dim sheet As Excel.Worksheet = GetSheetByIndex(ExcelApp.ActiveWorkbook, 2)
        Marshal.ReleaseComObject(sheet)
    End Sub

    Private Sub btnCodeName_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnCodeName.OnClick
        Dim text As String = GetWorksheetCodeName(ExcelApp.ActiveSheet)
    End Sub

    Private Sub btnCopySheet_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnCopySheet.OnClick
        CopyActiveSheet(True)
    End Sub

    Private Sub btnHide_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnHide.OnClick
        HideSheet(ExcelApp.ActiveSheet, False)
    End Sub

#End Region

End Class

